diff --git a/sysdeps/mach/hurd/Makefile b/sysdeps/mach/hurd/Makefile
index 4bfd290c09..a1ca034175 100644
--- a/sysdeps/mach/hurd/Makefile
+++ b/sysdeps/mach/hurd/Makefile
@@ -198,7 +198,8 @@ endif
 ifeq (io, $(subdir))
 sysdep_routines += f_setlk close_nocancel close_nocancel_nostatus \
 		   open_nocancel openat_nocancel read_nocancel \
-		   pread64_nocancel write_nocancel pwrite64_nocancel
+		   pread64_nocancel write_nocancel pwrite64_nocancel \
+		   wait4_nocancel
 endif
 
 ifeq (misc, $(subdir))
diff --git a/sysdeps/mach/hurd/not-cancel.h b/sysdeps/mach/hurd/not-cancel.h
index 7e824c5f11..69cd781f68 100644
--- a/sysdeps/mach/hurd/not-cancel.h
+++ b/sysdeps/mach/hurd/not-cancel.h
@@ -63,9 +63,13 @@ __typeof (__writev) __writev_nocancel;
 /* Non cancellable writev syscall with no status.  */
 void __writev_nocancel_nostatus (int fd, const struct iovec *vector, int count);
 
-/* For now we have none.  Map the name to the normal functions.  */
+/* Non cancellable wait4 syscall.  */
+__typeof (__wait4) __wait4_nocancel;
+
 # define __waitpid_nocancel(pid, stat_loc, options) \
-  __waitpid (pid, stat_loc, options)
+  __wait4_nocancel (pid, stat_loc, options, NULL)
+
+/* For now we have none.  Map the name to the normal functions.  */
 #define __fcntl64_nocancel(fd, cmd, ...) \
   __fcntl64 (fd, cmd, __VA_ARGS__)
 
@@ -80,6 +84,7 @@ hidden_proto (__write_nocancel)
 hidden_proto (__pwrite64_nocancel)
 hidden_proto (__writev_nocancel)
 hidden_proto (__writev_nocancel_nostatus)
+hidden_proto (__wait4_nocancel)
 #endif
 
 #endif /* NOT_CANCEL_H  */
diff --git a/sysdeps/mach/hurd/wait4.c b/sysdeps/mach/hurd/wait4.c
index 7cc969bf30..49c1b5d497 100644
--- a/sysdeps/mach/hurd/wait4.c
+++ b/sysdeps/mach/hurd/wait4.c
@@ -20,6 +20,7 @@
 #include <errno.h>
 #include <hurd.h>
 #include <hurd/port.h>
+#include <sysdep-cancel.h>
 
 pid_t
 __wait4 (pid_t pid, int *stat_loc, int options, struct rusage *usage)
@@ -29,10 +30,13 @@ __wait4 (pid_t pid, int *stat_loc, int options, struct rusage *usage)
   struct rusage ignored;
   int sigcode;
   int dummy;
+  int cancel_oldtype;
 
-  err = __USEPORT (PROC, __proc_wait (port, pid, options,
-				      stat_loc ?: &dummy, &sigcode,
-				      usage ?: &ignored, &dead));
+  cancel_oldtype = LIBC_CANCEL_ASYNC();
+  err = __USEPORT_CANCEL (PROC, __proc_wait (port, pid, options,
+					     stat_loc ?: &dummy, &sigcode,
+					     usage ?: &ignored, &dead));
+  LIBC_CANCEL_RESET (cancel_oldtype);
   switch (err)
     {
     case 0:			/* Got a child.  */
diff --git a/sysdeps/mach/hurd/wait4_nocancel.c b/sysdeps/mach/hurd/wait4_nocancel.c
new file mode 100644
index 0000000000..632f2e3ea0
--- /dev/null
+++ b/sysdeps/mach/hurd/wait4_nocancel.c
@@ -0,0 +1,54 @@
+/* Copyright (C) 1993-2020 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <errno.h>
+#include <hurd.h>
+#include <hurd/port.h>
+#include <not-cancel.h>
+
+pid_t
+__wait4_nocancel (pid_t pid, int *stat_loc, int options, struct rusage *usage)
+{
+  pid_t dead;
+  error_t err;
+  struct rusage ignored;
+  int sigcode;
+  int dummy;
+
+  err = __USEPORT (PROC, __proc_wait (port, pid, options,
+				      stat_loc ?: &dummy, &sigcode,
+				      usage ?: &ignored, &dead));
+  switch (err)
+    {
+    case 0:			/* Got a child.  */
+      return dead;
+    case EAGAIN:
+      /* The RPC returns this error when the WNOHANG flag is set and no
+	 selected children are dead (but some are living).  In that
+	 situation, our return value is zero.  (The RPC can't return zero
+	 for DEAD without also returning some garbage for the other out
+	 parameters, so an error return is much more natural here.  Hence
+	 the difference between the RPC and the POSIX.1 interface.  */
+      return (pid_t) 0;
+    default:
+      return (pid_t) __hurd_fail (err);
+    }
+}
+
+libc_hidden_def (__wait4_nocancel)